/*
 * mp3plot - Bitrate analysis tool
 *
 * Copyright (C) 2007 Toni Corvera
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

// $Id: mp3_element.h 715 2007-05-18 00:38:41Z  $

#ifndef ONET_MP3ELEMENT_H
#define ONET_MP3ELEMENT_H

#include <fstream>

#include "mp3_common.h"

namespace net_outlyer {

namespace mp3 {

    struct mp3element {
        virtual ~mp3element() {};
        virtual void read(std::ifstream & input) throw (e_error) = 0;
        static uint8_t bitrate_index(uint16_t kbps);
        protected:
            // Tests if input is ok to continue reading
            // if not it throws an e_read_failure
            static void check(const std::ifstream & input,
                              const std::string & failed_on="data") throw (e_read_failure);
    };

} // namespace mp3

} // namespace net_outlyer

#endif // ONET_MP3ELEMENT_H
/* vim:set ts=4 et ai: */

